﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Security.Cryptography;
using System.Text.RegularExpressions;
using System.Web;

namespace xonder
{
    public class XonderPayButton
    {
        // xonder gateway url, only change this when instructed by the intergrations team
        private Uri GATEWAY_URL = new Uri("https://mms.xonder.net/button/");
        private Uri REDIRECT_URL = new Uri("https://your.domain.com/rediret");
        // holds the request string
        private string reqString = "";
        // holds the response string
        private string resString = "";
        // holds the pre shared key
        private string sharedKey = "Circle4Take40Idea";

        public string merchantId { get; set; }
        public string action { get; set; }
        public int transType { get; set; }
        public string uniqueIdentifier { get; set; }
        public int currencyCode { get; set; }
        public int amount { get; set; }
        public String orderRef { get; set; }
        public string cardNumber { get; set; }
        public string cardExpiryMM { get; set; }
        public string cardExpiryYY { get; set; }
        public string cardCVV { get; set; }
        public string customerName { get; set; }
        public string customerEmail { get; set; }
        public string customerPhone { get; set; }
        public string customerAddress { get; set; }
        public int countryCode { get; set; }
        public string customerPostcode { get; set; }
        public string threeDSMD { get; set; }
        public string threeDSPaRes { get; set; }
        public string threeDSPaReq { get; set; }
        public string threeDSACSURL { get; set; }

        public string createSignature()
        {
            fillInfo();

            SortedDictionary<String, String> sortedDictionary = new SortedDictionary<string, string>();

            sortedDictionary.Add("merchantID", merchantId.ToString());
            sortedDictionary.Add("amount", amount.ToString());
            sortedDictionary.Add("action", action.ToString());
            sortedDictionary.Add("type", transType.ToString());
            sortedDictionary.Add("countryCode", countryCode.ToString());
            sortedDictionary.Add("currencyCode", currencyCode.ToString());
            sortedDictionary.Add("transactionUnique", uniqueIdentifier.ToString());
            sortedDictionary.Add("orderRef", orderRef.ToString());
            sortedDictionary.Add("redirectURL", REDIRECT_URL.ToString());
            sortedDictionary.Add("merchantData", "CS-PayByLink");

            //Build request String
            int count = 0;

            foreach (KeyValuePair<String, String> kvp in sortedDictionary)
            {
                if (count > 0)
                {
                    reqString += "&";
                }

                reqString += kvp.Key + "=" + urlEncode(kvp.Value);
                count++;
            }

            String Hashed = BitConverter.ToString(((SHA512)new SHA512Managed()).ComputeHash(Encoding.UTF8.GetBytes(
                Regex.Replace(reqString + sharedKey, @"%0D%0A|%0A%0D|%0D", "%0A")
            ))).Replace("-", "").ToLower();

            Console.WriteLine("Hash Returned From Hasher: " + Hashed);

            reqString += "&signature=" + Hashed;

            // Base64 Encode the string and remove any padding or invalid URL characters,
            // including =, + and / - Then return the pay button link
            var payButtonLink = base64Encode(reqString.Trim(new char[] { '=', '+', '/', '-', '_' }));
            return "<p><a href=\"" + GATEWAY_URL.ToString() + payButtonLink + "\">Pay Now</a></p>";
        }

        private void fillInfo()
        {
            merchantId = "TEST"; // For testing purposes - this would be your Merchant ID
            action = "SALE";
            transType = 1;
            uniqueIdentifier = "12345s6789c1";
            currencyCode = 826;
            amount = 1202; // VISA
            orderRef = "TestPurchase";
            cardNumber = "4012010000000000009"; // VISA
            cardExpiryMM = "12";
            cardExpiryYY = "14";
            cardCVV = "332";
            customerName = "xonder"; // VISA
            customerEmail = "solutions@xonder.net";
            customerPhone = "+44(0)8450099575";
            customerAddress = "31 Test Card Street";
            countryCode = 826;
            customerPostcode = "1TEST8";
        }

        string urlEncode(string value)
        {
            String newString = UpperCaseUrlEncode(value);
            newString = newString.Replace("!", "%21");
            newString = newString.Replace("*", "%2A");
            newString = newString.Replace("(", "%28");
            newString = newString.Replace(")", "%29");
            return newString;
        }

        public string UpperCaseUrlEncode(string value)
        {
            char[] charArray = HttpUtility.UrlEncode(value).ToCharArray();
            for (int i = 0; i < charArray.Length - 2; i++)
            {
                if (charArray[i] == '%')
                {
                    charArray[i + 1] = char.ToUpper(charArray[i + 1]);
                    charArray[i + 2] = char.ToUpper(charArray[i + 2]);
                }
            }

            return new string(charArray);
        }

        private string base64Encode(string toEncode)
        {
            var toBytes = Encoding.UTF8.GetBytes(toEncode);
            return Convert.ToBase64String(toBytes);
        }
    }
}
